package assets
{
	import flash.events.MouseEvent;
	import flash.filters.GlowFilter;
	
	import mx.controls.Button;

	public class ButtonEx extends Button
	{
		public function ButtonEx()
		{
			super();
			
			this.addEventListener(MouseEvent.MOUSE_OVER,mouseOverHandler);
		
			this.addEventListener(MouseEvent.MOUSE_OUT,mouseOutHandler);
			
			this.useHandCursor = true;
			this.buttonMode = true;
		}
		
		protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
			
			super.updateDisplayList(unscaledWidth,unscaledHeight);
				
						
		}
		
		private function mouseOverHandler(evt:MouseEvent):void
		{
			
			if(getStyle("textGlowColor") != null  && getStyle("textGlowColor") != "")
			{
				textField.filters = [new GlowFilter(getStyle("themeColor"),0.7,3,3)];
			}
			
		}
		
		private function mouseOutHandler(evt:MouseEvent):void
		{
			textField.filters = null;
			
		}
		
	}
}