package assets
{
	import flash.events.MouseEvent;
	import flash.filters.GlowFilter;	
	import mx.controls.Button;

	public class LinkButton extends Button
	{
		public function LinkButton(value:String ="")
		{
			super();
			this.label = value;
			this.addEventListener(MouseEvent.MOUSE_OVER,mouseOverHandler);
		
			this.addEventListener(MouseEvent.MOUSE_OUT,mouseOutHandler);
			
			useHandCursor =  true;
			buttonMode = true;
			this.styleName = "link";
		}
		
		protected override function commitProperties():void
		{
			//this.width = textField.textWidth +10;
			//this.height = 30;
			
		}
		
		
		
		protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
			
			super.updateDisplayList(unscaledWidth,unscaledHeight);
		
						
		}
		
		private function mouseOverHandler(evt:MouseEvent):void
		{
			
			if(getStyle("textGlowColor") != null  && getStyle("textGlowColor") != "")
			{
				textField.filters = [new GlowFilter(getStyle("themeColor"),0.7,3,3)];
			}
			
		}
		
		private function mouseOutHandler(evt:MouseEvent):void
		{
			textField.filters = null;
			
		}
	}
}