package infrastructure.database
{
	import flash.events.Event;
	
	import mx.collections.ArrayCollection;

	public class DatabaseEvent extends Event
	{
		public static const RESULT:String = "OnResult";
		public static const ERROR:String = "OnError";
		
		public var Result:ArrayCollection = null;
		
		public function DatabaseEvent(type:String, bubbles:Boolean=false, cancelable:Boolean=false, result:ArrayCollection=null)
		{
			super(type, bubbles, cancelable);
			Result = result;
		}
		
		override public function clone():Event
		{
			return new DatabaseEvent(type,bubbles,cancelable,Result); // bubbling support inside
		} 
		
	}
}