package modules.batchcataloger.assets
{
	
	import flash.display.GradientType;
	import flash.display.InterpolationMethod;
	import flash.display.SpreadMethod;
	import flash.geom.Matrix;
	
	import mx.core.UIComponent;

	public class ActionBar extends UIComponent
	{
		
		public function ActionBar()
		{
			super();
			
			this.styleName = "actionbarstyle";
		}
			
		
		protected override function createChildren():void
		{
			//this.addChild(background);
		}
		
		protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
			//super.updateDisplayList(unscaledWidth,unscaledHeight);
			
			
			this.graphics.clear();			
			
			var gradientBoxMatrix:Matrix = new Matrix();
            gradientBoxMatrix.createGradientBox(unscaledWidth, unscaledHeight,90, 0, 0);  

			this.graphics.beginGradientFill(GradientType.LINEAR, [getStyle("bodyColorbottom"),getStyle("bodyColormid"),getStyle("bodyColortop")], [1,1, 1], [0, 128, 255], gradientBoxMatrix,SpreadMethod.PAD,InterpolationMethod.RGB,1);

			//this.graphics.beginFill(getStyle("bodyColor"),1);
			this.graphics.drawRect(0, 0, unscaledWidth, unscaledHeight);
			this.graphics.beginFill(getStyle("embossTopColor"),1);
			this.graphics.drawRect(0, 0, unscaledWidth, 1);
			this.graphics.beginFill(getStyle("embossBottomFirstColor"),1);
			this.graphics.drawRect(0, unscaledHeight-2, unscaledWidth, 1);
			this.graphics.beginFill(getStyle("embossBottomLastColor"),1);
			this.graphics.drawRect(0, unscaledHeight-1, unscaledWidth, 1);
			
			
		
		}
		
	}
}