package framework.utils
{
	import air.net.SocketMonitor;
	import air.net.URLMonitor;
	
	import flash.events.StatusEvent;
	import flash.net.URLRequest;
	
	import infrastructure.statemanagement.StateMgr;
	
	import mx.controls.Alert;

    public class ConnectionManager
       {
           private var statusEvent:StatusEvent;
           private var urlMonitor:URLMonitor;
           

           [Bindable] public var connectionURL:String;
           [Bindable] public var isConnected:Boolean;    
          

           //3 Arguments, alert, connection URL, and the message to display
           public function ConnectionManager( connectionURL:String = "http://google.com")
           {
               this.connectionURL = connectionURL;
               
           }


           //Send a request to google, and see if we get a response
           public function startMonitor():void
           {
               var urlRequest:URLRequest = new URLRequest( connectionURL );
                   //urlRequest.method = "HEAD";

				//  urlMonitor.pollInterval = 500;
                   urlMonitor = new URLMonitor( urlRequest);
                   urlMonitor.addEventListener( StatusEvent.STATUS, statusChanged );
                   urlMonitor.start();
                   
                 //  var socketMonitor:SocketMonitor = new SocketMonitor(connectionURL,80);
				  // socketMonitor.addEventListener(StatusEvent.STATUS, statusChanged);
				 //  socketMonitor.start();

           }
           
           public function stopMonitor():void
           {
           		urlMonitor.stop();
           }

           

           //Dispatch a change event, whenever the status of our connection changes
           public function statusChanged( event:StatusEvent ):void
           {
               StateMgr.GetInstance().IsConnectedToServer = urlMonitor.available;
       
       		//Alert.show(StateMgr.GetInstance().IsConnectedToServer.toString());
           
               statusEvent = new StatusEvent( StatusEvent.STATUS );

               dispatchEvent( statusEvent );            
           }

       }
}