
	import assets.TopBar;
	
	import deng.fzip.FZip;
	
	import flash.desktop.NativeApplication;
	import flash.desktop.SystemTrayIcon;
	import flash.desktop.Updater;
	import flash.display.NativeWindowInitOptions;
	import flash.events.BrowserInvokeEvent;
	import flash.events.Event;
	import flash.events.InvokeEvent;
	import flash.events.MouseEvent;
	import flash.events.StatusEvent;
	import flash.filesystem.File;
	import flash.filesystem.FileMode;
	import flash.filesystem.FileStream;
	import flash.net.URLRequest;
	import flash.utils.ByteArray;
	import flash.utils.Timer;
	
	import framework.constants.ADMODULE;
	import framework.constants.COMMON;
	import framework.constants.COMMONSTRINGS;
	import framework.constants.DATABASE;
	import framework.constants.EVENTS;
	import framework.constants.MODULES;
	import framework.constants.QUERY;
	import framework.constants.STRINGS;
	import framework.constants.remotemethods.INFRASTRUCTURE;
	import framework.constants.tables.AUTOUPDATE;
	import framework.constants.tables.PREFERENCE;
	import framework.constants.tables.SCHEDULE;
	import framework.dialogs.MessageBox;
	import framework.events.MigrationEvent;
	import framework.migration.MigrationManager;
	import framework.preference.PreferenceUI;
	import framework.remoteobjects.Session;
	import framework.statusbar.CustomStatusBar;
	import framework.updater.AutoUpdateConfig;
	import framework.updater.AutoUpdateManager;
	import framework.utils.ConnectionManager;
	import framework.utils.Helper;
	import framework.utils.SessionUtil;
	import framework.utils.WorkInProgress;
	
	import infrastructure.database.DataAccess;
	import infrastructure.statemanagement.StateMgr;
	
	import modules.splashpage;
	
	import mx.collections.ArrayCollection;
	import mx.controls.Alert;
	import mx.controls.Button;
	import mx.controls.Menu;
	import mx.core.Application;
	import mx.core.ClassFactory;
	import mx.events.CloseEvent;
	import mx.events.MenuEvent;
	import mx.events.ModuleEvent;
	import mx.formatters.SwitchSymbolFormatter;
	import mx.messaging.ChannelSet;
	import mx.messaging.channels.AMFChannel;
	import mx.messaging.channels.SecureAMFChannel;
	import mx.modules.ModuleLoader;
	import mx.rpc.events.FaultEvent;
	import mx.rpc.events.ResultEvent;
	import mx.rpc.remoting.mxml.RemoteObject;
	import mx.states.State;
	import mx.utils.Base64Encoder;
	
		
	private static var _amfChannel:AMFChannel = null;
	[Bindable]
	public static var amfChannelSet:ChannelSet = null;
		
		public var _root:NativeMenu
		
		[Bindable]
        private var arglist:ArrayCollection;
        [Bindable]
        private var e:BrowserInvokeEvent;
        
        [Bindable]
		public static var da:DataAccess;
				  
		public var autoUpdateDetails:ArrayCollection;
		
		public var mainModule:ModuleLoader;
		public var main:splashpage;
		private var topBar:TopBar;
		private var optionsDialog:Menu;
		private var dataSyncThread:Timer;
		private var fascade:RemoteObject;
		//screens
		private var preferenceScreen:PreferenceUI = null;
		private var connectionMgr:ConnectionManager;
		private var migrationMgr:MigrationManager;		
		
		
		 /**
	     *
	     * Hanlder for PreInitialize event　
	     *
	     */
		public function preinit():void 
		{
			try
			{					
				StateMgr.GetInstance();			
				
				CreateDefaultDatabase();
											
				CreateDefaultFolders();
										
				CreateDefaultLocalizationFiles();				
			    
			    //hook tok browser and involke events
				NativeApplication.nativeApplication.addEventListener(BrowserInvokeEvent.BROWSER_INVOKE,onBrowserInvoke);				
          		NativeApplication.nativeApplication.addEventListener( InvokeEvent.INVOKE, onInvoke );
          		
          		//initialize the top bar
				topBar = new TopBar();
				topBar.x = 0;
				topBar.y = 0;
				topBar.percentWidth = 100;
				topBar.height = 25;
				this.addChild(topBar);
				
				topBar.PreferenceBtn.addEventListener(MouseEvent.CLICK,preferenceHandler);
				topBar.HelpBtn.addEventListener(MouseEvent.CLICK,helpHandler);
				topBar.AboutBtn.addEventListener(MouseEvent.CLICK,aboutHandler);
				topBar.OptionsBtn.addEventListener(MouseEvent.CLICK,optionsHandler);
				
				//create instance of migration manager 
				migrationMgr= new MigrationManager();
				
				
				//retrieve user id
				StateMgr.GetInstance().UserId = (da.ResultSet[0][PREFERENCE.VALUE] == null?"":da.ResultSet[0][PREFERENCE.VALUE]);
			 	//load the default module
				mainModule = new ModuleLoader();
				mainModule.url = "modules/splashpage.swf";
				mainModule.percentWidth = 100;
				mainModule.percentHeight = 100;	
				
				mainModule.addEventListener(ModuleEvent.READY,mainloaded);
				mainModule.x = 0;
				mainModule.y = topBar.Height;				
				this.addChild(mainModule); 
				
				preferenceScreen = new PreferenceUI();
				preferenceScreen.visible = false;
				preferenceScreen.addEventListener(EVENTS.PREFERENCE_CHANGED,preferenceChangeHandler);
				this.addChild(preferenceScreen);
				
				
				//OptionsDialogData.appendChild(createTicketOption);
				
				optionsDialog = Menu.createMenu(this, null, false);
				optionsDialog.labelField="@label"
                optionsDialog.addEventListener("itemClick", optionsMenuHandler);
			
				this.statusBarFactory = new ClassFactory(CustomStatusBar);
				this.addEventListener(EVENTS.DATA_SYNCED,dataSynced);
				this.addEventListener(EVENTS.RESYNC_DATA, resyncDataHandler);
				this.addEventListener(EVENTS.MODULE_LOADED,defaultModuleLoadedHandler);
				this.addEventListener(MigrationEvent.MIGRATE+MODULES.BASE_FRAMEWORK,schemaMigrationHandler);
				this.addEventListener(EVENTS.DISABLE_LANGUAGE_MENU, disableLanguageMenuHandler);
				this.addEventListener(framework.constants.EVENTS.ENAABLE_LANGUAGE_MENU, enableLanguageMenuHandler);
			}
			catch(ex:Error)
			{				
				MessageBox.Show(ex.toString(),"Pre Initialize");
			}			
		}

		
		
		 /**
	     *
	     * Hanlder for Initialize event　
	     *
	     */
		public function init():void 
		{		
			try
			{
			if(IsUpdatesAvailable())
			{
				if(IsUpdateCritical())
				{
		           da.DataAccessUpdate("UPDATE AUTOUPDATE SET VALUE='true' where NAME='Updated'");
		           
		           var updater:Updater = new Updater();
			        var file:File
			            = Helper.CreateCacheDirectory(COMMON.CACHE_FOLDERNAME).resolvePath("MOMDesktop.air");
			        updater.update(file, AUTOUPDATE.GetValue(autoUpdateDetails,"NewVersion"));
	   			}
	   			else
	   			{
					var adfXml:XML = NativeApplication.nativeApplication.applicationDescriptor;
			        var adfXmlNs:Namespace = adfXml.namespace();
			     	 MessageBox.Show(
		            "MOM Desktop new version is available.\nDo you want to update?\n Current Version:"
		                + adfXml.adfXmlNs::version
		                + "\n New Version:"
		                + AUTOUPDATE.GetValue(autoUpdateDetails,"NewVersion")
		            ,"Update"
		            ,__confirmUpdateCloseHandler
		            ,MessageBox.YES | MessageBox.NO);
	   			}
			}
			}
			catch(ex:Error)
			{				
				MessageBox.Show(ex.toString(),"Initialize");
			}			
		}
		
		private function __confirmUpdateCloseHandler(event:CloseEvent):void
	    {
	        if(event.detail == MessageBox.OK)
	        {
	           da.DataAccessUpdate("UPDATE AUTOUPDATE SET VALUE='true' where NAME='Updated'");
	           
	           var updater:Updater = new Updater();
		       var file:File
		            = Helper.CreateCacheDirectory(COMMON.CACHE_FOLDERNAME).resolvePath("MOMDesktop.air");
		        updater.update(file, AUTOUPDATE.GetValue(autoUpdateDetails,"NewVersion"));
	        }
	        else
	        {
	            da.DataAccessUpdate("UPDATE AUTOUPDATE SET VALUE='true' where NAME='Updated'");
	        }
	    }
		
		 /**
	     *
	     * Hanlder for Creation complete event　
	     *
	     */
		public function load():void 
		{				
			try
			{	
				var login:String = da.ResultSet[0][PREFERENCE.VALUE];
				//var password:String = da.ResultSet[1][PREFERENCE.VALUE];
				var password:String = SessionUtil.GetPassword();
				var server:String = da.ResultSet[2][PREFERENCE.VALUE];
				var tenant:String = da.ResultSet[3][PREFERENCE.VALUE];
				
		   
			 
			   StateMgr.GetInstance().UserId = login;
			
			   if(server == null || server == "" || tenant == null || tenant == "" || login == null || login == "")
			   {
				   preferenceScreen.show(true);
			   }
			   else
			   {
			   	// DoSchemaSanityCheck(FunctionForLoad);				  	
				   
				   FunctionForLoad(); 
			  
			   }
			
			}
			catch(ex:Error)
			{
				MessageBox.Show(ex.toString(),"Load");
			}			
		}
		
		private function FunctionForLoad():void
		{
			var login:String = da.ResultSet[0][PREFERENCE.VALUE];
			//var password:String = da.ResultSet[1][PREFERENCE.VALUE];
			var password:String = SessionUtil.GetPassword();
			var server:String = da.ResultSet[2][PREFERENCE.VALUE];
			var tenant:String = da.ResultSet[3][PREFERENCE.VALUE];
			StartServerMonitoring();
	   		var protocol:String = server.split(":")[0];						   		
			InitializeRemoteObject(protocol,server+"/"+tenant+"/Default.aspx");
			DoLogin(login,password,tenant);	
		}
		
		private function DoLogin(login:String,password:String,tenant:String):void
		{
			 StateMgr.GetInstance().Fascade.getOperation(INFRASTRUCTURE.VALIDATE_USER).addEventListener(ResultEvent.RESULT, validateUserHandler);
			 StateMgr.GetInstance().Fascade.ValidateUser(login,password,tenant);	
		}
		
		private function IsUpdatesAvailable():Boolean
		{
			if(AUTOUPDATE.GetValue(autoUpdateDetails,"Updated") == "true")
			{
				return false;				
			}
			else
			{
				return true;
			}
		}
		
		private function IsUpdateCritical():Boolean
		{
			if(AUTOUPDATE.GetValue(autoUpdateDetails,"Critical") == "true")
			{
				return true;				
			}
			else
			{
				return false;
			}
		}
		
		 /**
	     *
	     * Hanlder for PreInitialize event　
	     *
	     */
		private function ProcessScheduledTask(forceUpdate:Boolean = false):void
		{			
			if(!forceUpdate)
			{
		  	  da.DataAccessSelect("SELECT * FROM SCHEDULE",ScheduleTaskHandler)	
			}
			else
			{
				StampDatabase(COMMON.PROCESS_SYNC_DATA);
				Application.application.dispatchEvent(new Event(EVENTS.SYNC_DATA));
			}
	    }
	    
		private function ScheduleTaskHandler(result:ArrayCollection):void
		{
			for(var i:int = 0; i<result.length; i++)
			{
				switch(result[i][SCHEDULE.NAME])
				{
					case "SyncData": InitiateSyncData(result[i]);
									break;
					case "AutoUpdate": InitiateAutoUpdate(result[i]);
									break;									
				}
			}
			
		}
		
		private function resyncDataHandler(evt:Event):void
		{	
			InitiateSyncData();
		}
		
		private function InitiateSyncData(record:Object=null):void
		{		
			if(record == null || record[SCHEDULE.LASTEXECUTEDON] == null || record[SCHEDULE.LASTEXECUTEDON] == "")
			{	
				StampDatabase(COMMON.PROCESS_SYNC_DATA);
				Application.application.dispatchEvent(new Event(EVENTS.SYNC_DATA));
			} 
			else
			{
				try
				{
					//Code changes done to Sync Data Always
					StampDatabase(COMMON.PROCESS_SYNC_DATA);
					Application.application.dispatchEvent(new Event(EVENTS.SYNC_DATA));
					
					/*var interval:Number = Number(record[SCHEDULE.INTERVAL]);
					var timeStamp:String = record[SCHEDULE.LASTEXECUTEDON];
					var timeStampArray:Array = timeStamp.split('-');
					var lastExecutedOn:Date = new Date(timeStampArray[2],timeStampArray[1],timeStampArray[0],timeStampArray[3],timeStampArray[4],timeStampArray[5]);
					
					var diffInHours:int = Helper.CalculateHours(lastExecutedOn,new Date());
					if(diffInHours > interval)
					{
						StampDatabase(COMMON.PROCESS_SYNC_DATA);
						Application.application.dispatchEvent(new Event(EVENTS.SYNC_DATA));
					}*/
				}
				catch(ex:Error)
				{
					MessageBox.Show(ex.toString(),"Scheduler");
				}
			}
		}
		
		private function InitiateAutoUpdate(record:Object):void
		{
			var interval:Number = Number(record[SCHEDULE.INTERVAL]);
			var checkForUpdate:Boolean = false;
			if(record[SCHEDULE.LASTEXECUTEDON] == null || record[SCHEDULE.LASTEXECUTEDON] == "")
			{	
				StampDatabase(COMMON.PROCESS_AUTO_UPDATE);
				checkForUpdate =  true;
			} 
			else
			{
				try
				{
					var timeStamp:String = record[SCHEDULE.LASTEXECUTEDON];
					var timeStampArray:Array = timeStamp.split('-');
					var lastExecutedOn:Date = new Date(timeStampArray[2],timeStampArray[1],timeStampArray[0],timeStampArray[3],timeStampArray[4],timeStampArray[5]);
					
					var diffInHours:int = Helper.CalculateHours(lastExecutedOn,new Date());
					if(diffInHours > interval)
					{
						StampDatabase(COMMON.PROCESS_AUTO_UPDATE);
						checkForUpdate =  true;
					}
				}
				catch(ex:Error)
				{
					MessageBox.Show(ex.toString(),"Scheduler");
				}
			}
			
			if(checkForUpdate)
			{
				var login:String = da.ResultSet[0][PREFERENCE.VALUE];
			  	//var password:String = da.ResultSet[1][PREFERENCE.VALUE];
				var password:String = SessionUtil.GetPassword();
				var server:String = da.ResultSet[2][PREFERENCE.VALUE];
				var tenant:String = da.ResultSet[3][PREFERENCE.VALUE];
				   
				var config:AutoUpdateConfig = new AutoUpdateConfig(server,tenant+"/AssetlinkDesktopInstaller","MOMDesktop.air","updateversion.xml");
				var updateMgr:AutoUpdateManager = new AutoUpdateManager(config);
				updateMgr.CheckForUpdate();
			}
		}
		
		 private function statusChanged( event:StatusEvent ):void
           {
               
                Application.application.dispatchEvent(event);
               
				if(StateMgr.GetInstance().IsConnectedToServer)
				{
					
				}       
				else
				{
					
				}
       		           
           }


	
           
        private function validateUserHandler(event:ResultEvent):void
		{			
			var session:Session = event.result as Session;
			
			
			
			if(session == null)
			{
				
			}
			else
			{
				//do the version check for compatability with server
				/*if(session.hasOwnProperty("ExpectedADVerion"))
				{
				   if(session.ExpectedADVerion != Helper.GetAssetlinkDesktopVersion())
				   {
				   	 if(session.ExpectedADVerion != null && session.ExpectedADVerion != "")
				   	 {
				   	 	MessageBox.Show(STRINGS.ERROR_DESKTOP_NOT_COMPATIBLE_WITH_SERVER + session.ExpectedADVerion,STRINGS.MESSAGE_HEADER_ERROR,versionCheckHandler);
				   	 }
				   	 else
				   	 {
				   	 	MessageBox.Show(STRINGS.ERROR_DESKTOP_NOT_COMPATIBLE_WITH_SERVER + "1.0.1.0",STRINGS.MESSAGE_HEADER_ERROR,versionCheckHandler);
				   	 }			   	
				   }
				}*/
				
				StateMgr.GetInstance().SessionObject = session;
				 
				ProcessScheduledTask();	
				InitializeInfrastructure();
				
				StateMgr.GetInstance().Fascade.getOperation(INFRASTRUCTURE.GET_LOCALIZATION_XML).removeEventListener(ResultEvent.RESULT, localizationXMLHandler);
				StateMgr.GetInstance().Fascade.getOperation(INFRASTRUCTURE.GET_LOCALIZATION_XML).addEventListener(ResultEvent.RESULT, localizationXMLHandler);
				StateMgr.GetInstance().Fascade.GetLocalizationXML(StateMgr.GetInstance().SessionObject);
			}
		}
		
		
		private function versionCheckHandler(evt:CloseEvent):void
		{
			//NativeApplication.nativeApplication.exit(0);			
			preferenceScreen.show();
		}
		
		private function InitializeRemoteObject(protocol:String,serverurl:String):void
		{
			amfChannelSet = new ChannelSet();
		
			if (protocol == "http")
			{
				var amfChannel:AMFChannel = new AMFChannel(COMMON.REMOTING_ID, serverurl);
			  	amfChannel.netConnection.objectEncoding = ObjectEncoding.AMF3;
		 		amfChannelSet.addChannel(amfChannel);
		 	}
		 	else
		 	{
		  		var secureAmfChannel:SecureAMFChannel = new SecureAMFChannel(COMMON.SECURE_REMOTING_ID, serverurl);
			  	secureAmfChannel.netConnection.objectEncoding = ObjectEncoding.AMF3;
		 		amfChannelSet.addChannel(secureAmfChannel);
		  	}
		  
		  	if(fascade !=  null)
		  	{
		  		fascade.removeEventListener(FaultEvent.FAULT,faultHandler);
		  	}
		  	fascade = new RemoteObject(COMMON.REMOTING_DESTINATION);
			fascade.channelSet = amfChannelSet;
			fascade.source = COMMON.REMOTING_SERVICE;
			fascade.addEventListener(FaultEvent.FAULT,faultHandler);	
			
			  	
			StateMgr.GetInstance().Fascade = fascade;
		}
		
		
		
		private function InitializeInfrastructure():void
		{
			var loginname:String = da.ResultSet[0][PREFERENCE.VALUE];
			   
			 StateMgr.GetInstance().UserId = loginname;
						
			 CreateDefaultFolders();
			 
			// CreateDefaultDatabase();
	         
		}
		
		private function CreateDefaultFolders():void
		{
			 //Helper.CreateHotDirectory(COMMON.HOT_FOLDERNAME);
	        // Helper.CreateHotDirectory(COMMON.HOT_FOLDERNAME+"/"+StateMgr.GetInstance().UserId);			
	         Helper.CreateCacheDirectory(COMMON.CACHE_FOLDERNAME);
	         Helper.CreateCacheDirectory(COMMON.CACHE_FOLDERNAME+"/db");
	         Helper.CreateCacheDirectory(COMMON.CACHE_FOLDERNAME+"/"+StateMgr.GetInstance().UserId);
		}

		private function CreateDefaultLocalizationFiles():void
		{			
			var localizationFilePath:String = File.userDirectory.resolvePath(COMMON.CACHE_FOLDERNAME + "/" +COMMON.FILE_LOCALIZATION).nativePath;
			
			var localizationFile:File = new File(localizationFilePath);
			
			if(!localizationFile.exists)
			{
				var localizationFileOrg:File = new File("app:/resources/"+COMMON.FILE_LOCALIZATION);
				localizationFileOrg.copyTo(localizationFile);
			}
			
		}
		
		private function CreateDefaultDatabase():void
		{	 
			 var desktopDB:File = new File(DATABASE.MAIN);
	          
	         if(!desktopDB.exists)
	          {
		          var desktopDBOrg:File = new File(DATABASE.DEFAULT_MAIN);
		          desktopDBOrg.copyTo(desktopDB);
	          }
	         
			 
	         var catalogerDB:File = new File(DATABASE.CATALOGER);
	          
	         if(!catalogerDB.exists)
	          {
		          var catalogerDBOrg:File = new File(DATABASE.DEFAULT_CATALOGER);
		          catalogerDBOrg.copyTo(catalogerDB);
	          }	          
			 
			 da = new DataAccess(DATABASE.MAIN);
			 da.openConnection(QUERY.SELECT_PREFERENCE);
			 da.DataAccessSelect(QUERY.SELECT_AUTOUPATE,autoUpdateResultHandler);
			
			 Helper.GetLoggerInstance(da);
			 
			 StateMgr.GetInstance().MainDatabase = da;
			 
				
		}
		
		private function autoUpdateResultHandler(result:ArrayCollection):void
		{			
			autoUpdateDetails = result;
		}
		
		
		
		private function faultHandler(evt:FaultEvent):void
		{
			WorkInProgress.HideAll();
			
			MessageBox.Show(STRINGS.ERROR_COULD_NOT_CONNECT_TO_SERVER);
		
			StateMgr.GetInstance().logger.Write(ADMODULE.INFRASTRUCTURE,"assetlinkdesktop.as-faulthandler()",evt.toString());			
		}
			
		private function aboutHandler(event:MouseEvent):void
		{
			MessageBox.Show(STRINGS.ABOUT_MESSAGE + " "  + Helper.GetAssetlinkDesktopVersion());
		}
		
		private function optionsHandler(event:MouseEvent):void
		{	
			var clickBtn:Button = event.currentTarget as Button;
			var posX:Number = clickBtn.x;
			var posY:Number = clickBtn.y + clickBtn.height; 
			optionsDialog.show(posX, posY);
		}
		
		private function optionsMenuHandler(evt:MenuEvent):void
		{
			switch(String(evt.item.@data))
			{
				case COMMON.MENU_OPTIONS_CREATETICKET: 
					 CreateTicketHandler();
					 break;
				case COMMON.MENU_OPTIONS_RESETDATA: 
					 ResetDataConfirm();
					 break;
				case COMMON.MENU_OPTIONS_LANGUAGE:
					da.DataAccessUpdate("UPDATE PREFERENCE SET VALUE='"+evt.item.@label+"' where NAME='"+da.ResultSet[7][PREFERENCE.NAME]+"'");
					 UpdateLanguage(evt.item.@label);
					 break;
			}
			
		}	

		
		private function ResetDataConfirm():void
		{
			MessageBox.Show(STRINGS.MESSAGE_RESETDATA_CONFIRM, STRINGS.MESSAGE_HEADER_RESETDATA,ResetDataHandler,MessageBox.YES|MessageBox.NO);
		}
		
		private function ResetDataHandler(e:CloseEvent):void
		{	
			if (e.detail == MessageBox.YES)
			{
				Application.application.dispatchEvent(new Event(EVENTS.RESET_DATA));
				DeleteDataBaseFiles();
				
				StateMgr.GetInstance().logger = null;
					 
				CreateDefaultDatabase();
				preferenceScreen.init();
				preferenceScreen.show(true);	
			}
		}
		
		private function DeleteDataBaseFiles():void
		{	
			if (da != null)
				da.closeConnection();
			
			var desktopDB:File = new File(DATABASE.MAIN);
	        if(desktopDB.exists)
	        {
		        desktopDB.deleteFile();
	        }
		}
		
		private function CreateTicketHandler():void
		{
			var file:File = new File();
			file.addEventListener(Event.SELECT,onSelect);
			file.browseForDirectory(STRINGS.MESSAGE_SELECTION_TICKET_LOCATION);
			
		}
		
		private  function onSelect(evt:Event):void
		{
			var targetFolder:File = new File(evt.target.nativePath + "/" + COMMON.FILE_TICKET_ZIP);
			
			var detailsStr:String = STRINGS.SYSTEMDETAILS_OPERATING_SYSTEM + " " + flash.system.Capabilities.os;
			detailsStr += "\r\n" + STRINGS.SYSTEMDETAILS_AIR_VERSION + " " + flash.system.Capabilities.version;
			
			var desktopDB:File = new File(DATABASE.MAIN);
			var desktopStream:FileStream = new FileStream();
			desktopStream.open(desktopDB,FileMode.READ);
			var desktopBytes:ByteArray = new ByteArray();
			desktopStream.readBytes(desktopBytes,0,desktopStream.bytesAvailable);
			desktopStream.close();
			
			var catalogerDB:File = new File(DATABASE.CATALOGER);
			var catalogerStream:FileStream = new FileStream();
			catalogerStream.open(catalogerDB,FileMode.READ);
			var catalogerBytes:ByteArray = new ByteArray();
			catalogerStream.readBytes(catalogerBytes,0,catalogerStream.bytesAvailable);
			catalogerStream.close();
			
			var zip:FZip = new FZip();
			zip.addFileFromString(COMMON.FILE_SYSTEM_DETAILS, detailsStr);
			zip.addFile(COMMON.FILE_DESKTOP_DB,desktopBytes);
			zip.addFile(COMMON.FILE_CATALOGER_DB,catalogerBytes);
			
			var stream:FileStream = new FileStream();
			stream = new FileStream();
            stream.openAsync(targetFolder, FileMode.WRITE);
            zip.serialize(stream);
            stream.close();
		}

		private function GetLanguageOptions(selectedLanguage:String, disableLanguages:Boolean=false):XML
		{
			var languageOption:String = "<menuitem label=\""+ Helper.EncodeSpecialChars(STRINGS.OPTIONS_LANGUAGE) + "\"" + " data=\"" + Helper.EncodeSpecialChars(COMMON.MENU_OPTIONS_LANGUAGE) + "\">";
			try
			{
				var cacheFolder:File = Helper.CreateCacheDirectory(COMMON.CACHE_FOLDERNAME );
				
				var file:File= new File(cacheFolder.nativePath + "/" + COMMON.FILE_LOCALIZATION);
				
				var fs:FileStream = new FileStream();
				fs.open(file, FileMode.READ);
				var languages:XML = XML(fs.readUTFBytes(fs.bytesAvailable));
				var languageList:XMLList = languages.language;
				for each(var language:XML in languageList)
				{
					
					var selected:String = "";
					if(selectedLanguage == language.@name)
					{
						selected = "toggled=\"true\"";	
					}
					
					languageOption += "<menuitem label=\""+ Helper.EncodeSpecialChars(language.@name) +"\" data=\"" + Helper.EncodeSpecialChars(COMMON.MENU_OPTIONS_LANGUAGE) + "\" type=\"radio\" groupName=\"one\" "+selected+" enabled=\"" + !disableLanguages + "\"/>";
					
				}
				fs.close();
			}
			catch(ex:Error)
			{
				MessageBox.Show(STRINGS.ERROR_LOADING_LANGUAGES);
				StateMgr.GetInstance().logger.Write("Initialize","GetLanguageOptions",ex.toString());
				
			}
			languageOption += "</menuitem>";
			return XML(languageOption); 
		}

		
		private function helpHandler(event:MouseEvent):void
		{
			//MessageBox.Show(STRINGS.HELP_MESSAGE);
			/*var options = new NativeWindowInitOptions();
			options.systemChrome = "none";
			options.type = "lightweight";
			
			var windowBounds = new Rectangle(200,250,300,400);
			var newHTMLLoader:* = HTMLLoader.createRootWindow(true, options, true, windowBounds);
			newHTMLLoader.load(new URLRequest("Help/home.html"));
			*/
			createNativeWindow();

		}
		
		public function createNativeWindow():void 
		{
		   
		   var initOptions:NativeWindowInitOptions = new NativeWindowInitOptions();
			var bounds:Rectangle = new Rectangle(10, 10, 600, 400);
			var html2:HTMLLoader = HTMLLoader.createRootWindow(true, initOptions, true, bounds);
			var helpfileUrl:String = getHelpFileUrl();
			var urlReq2:URLRequest = new URLRequest(helpfileUrl);
			html2.load(urlReq2);
			html2.stage.nativeWindow.activate();			
		
		}

		
		private function getHelpFileUrl():String
		{
			var helpFileUrl:String = "Help/home.html";
			var currentCulture:String = StateMgr.GetInstance().CurrentCulture;
			switch(currentCulture.toLowerCase())
			{
				case "en-us":
					helpFileUrl = "Help/en-us/home.html";
					break;
				case "de-de":
					helpFileUrl = "Help/de-de/home.html";
					break;
				case "ja-jp":
					helpFileUrl = "Help/ja-jp/home.html";
					break;
				case "zh-cn":
					helpFileUrl = "Help/zh-cn/home.html";
					break;
				default:
					helpFileUrl = "Help/home.html";
					break;
			}
			return helpFileUrl;
			 
		}
		
		private function preferenceHandler(event:MouseEvent):void
		{
			preferenceScreen.show();
		}
		
		private function StartServerMonitoring():void
		{
			if(connectionMgr != null)
			{
		   		connectionMgr.removeEventListener(StatusEvent.STATUS, statusChanged);
		   		connectionMgr.stopMonitor();
			}
			
			var server:String = da.ResultSet[2][PREFERENCE.VALUE];
		 	var tenant:String = da.ResultSet[3][PREFERENCE.VALUE];
		 	
			connectionMgr = new ConnectionManager(server+"/"+tenant+"/Default.aspx");
	   		connectionMgr.addEventListener(StatusEvent.STATUS, statusChanged);
	   	    connectionMgr.startMonitor();		   	   
		 	
		}
		
		private function preferenceChangeHandler(evt:Event):void
		{
			this.callLater(RefreshModuleData);
			WorkInProgress.Show(STRINGS.WIP_CONFIGURING_SYSTEM);
			
		}
		
		private function dataSynced(evt:Event):void
		{
			WorkInProgress.Hide(STRINGS.WIP_CONFIGURING_SYSTEM);
			WorkInProgress.Hide(STRINGS.WIP_RESYNCING_WITH_SERVER);
		}
		
		private function RefreshModuleData():void
		{
			
			var server:String = da.ResultSet[2][PREFERENCE.VALUE];
			var tenant:String = da.ResultSet[3][PREFERENCE.VALUE];
			
			DoSchemaSanityCheck(FunctionsForPreferenceChange);
		}
		
		private function FunctionsForPreferenceChange():void
		{
			var server:String = da.ResultSet[2][PREFERENCE.VALUE];
			var tenant:String = da.ResultSet[3][PREFERENCE.VALUE];
			
			StartServerMonitoring();  
			var protocol:String = server.split(":")[0];
			
			//InitializeRemoteObject("http://"+server+"/"+tenant+"/Default.aspx"); 
			InitializeRemoteObject(protocol,server+"/"+tenant+"/Default.aspx");
			
			
			InitializeInfrastructure();
			
			//RetrieveCatalogerData();
			
			ProcessScheduledTask(true);
			
			StateMgr.GetInstance().Fascade.getOperation(INFRASTRUCTURE.GET_LOCALIZATION_XML).removeEventListener(ResultEvent.RESULT, localizationXMLHandler);
			StateMgr.GetInstance().Fascade.getOperation(INFRASTRUCTURE.GET_LOCALIZATION_XML).addEventListener(ResultEvent.RESULT, localizationXMLHandler);
			StateMgr.GetInstance().Fascade.GetLocalizationXML(StateMgr.GetInstance().SessionObject);	
			
			Application.application.dispatchEvent(new Event(EVENTS.PREFERENCE_CHANGED));
		}
		
	
		
		
		private function StampDatabase(task:String):void
		{
			da.DataAccessUpdate("UPDATE SCHEDULE SET LASTEXECUTEDON='"+Helper.GetCurrentDateTimeStamp(true)+"' where NAME='"+task+"'");
		}	
		
		private function onInvoke( e:InvokeEvent ):void 
        { 
        	//Alert.show("invoke ");
            	//Alert.show(e.arguments.toString());
        	// this.arglist = new ArrayCollection( e.arguments );
                //Alert.show("invoke "+this.arglist.getItemAt(0).toString());
                //this.e = e;
           /* if( event.reason == InvokeEventRea.LOGIN ) 
            { 
                //do background processing... 
                trace( "Running in background..." ); 
            }             
            else 
            { 
                this.stage.nativeWindow.activate(); 
            } */
        } 

		
		 
            private function onBrowserInvoke(e:BrowserInvokeEvent):void 
            {
            	//Alert.show("binvoke ");
            	try
            	{    
                	this.arglist = new ArrayCollection( e.arguments );
                //	Alert.show("binvoke "+this.arglist.getItemAt(0).toString());
                	this.e = e;
             	}
             	catch(ex:Error)
             	{
             		MessageBox.Show(ex.toString(),"Browser Invoke");             
             	}
            }
		private function exitApp(e:Event):void
		{
			stage.nativeWindow.close()
		}
		
		private function mainloaded(event:ModuleEvent):void {
				
				main = splashpage(mainModule.child);      
                var moduleTitle:String = main.getModuleTitle();
              
            }
            
        private function DoSchemaSanityCheck(nextControlFlow:Function):void
        {    
        	var currentSchemaVersion:Number = 1.0; //default schema version
			try
			{
				currentSchemaVersion = Number(da.ResultSet[5][PREFERENCE.VALUE]);
			}
			catch(ex:Error)
			{
				//schema version entry was not present in Relase 5 build of Assetlink
				//or we can say in 1.0.1.0 version of AssetlinkDesktop
			}
			
	  		var expectedSchemaVersion:Number =  Helper.GetSchemaVersion();
	  		
		   if(currentSchemaVersion != expectedSchemaVersion)
		   {
		   		if(currentSchemaVersion < expectedSchemaVersion)
		   		{
			  	 	WorkInProgress.Show(STRINGS.WIP_MIGRATING_SCHEMA);
				
					this.callLater(migrationMgr.start,[currentSchemaVersion,expectedSchemaVersion,nextControlFlow]);
		   		}
		   		else
		   		{
		   			//MessageBox.Show(STRINGS.WARNING_APP_DOWNGRADE_SCHEMA_CLEAR_WARNING,STRINGS.MESSAGE_HEADER_WARNING);
		   		}
		   }
		   else
		   {
			   if(nextControlFlow != null)
			   {
			     nextControlFlow();
			   }
			}
        }    

		private function migartionRefreshStepsforVersion(version:String):void
		{
			switch(version)
			{
				case "2.0": 	
					break;
			}
		}
        
        private function schemaMigrationHandler(evt:MigrationEvent):void
        {
			var toVersion:String = evt.Data.toVersion;
			var module:XML = XML(evt.Data.module);
			
			if(module.@refresh != null && module.@refresh.toString() != "")
			{
				if(module.@refresh.toString() == "true")
				{
					migartionRefreshStepsforVersion(toVersion);
				}
			}
			
           var queries:XMLList = module.children();
           for ( var i:Number = 0 ; i < queries.length() ; i++ )
			  {
			  	var query:XML = queries[i];
			    da.DataAccessExecute(query.toString());
			  }
			  
			  da.DataAccessSelect(QUERY.SELECT_PREFERENCE);
        }

        private function defaultModuleLoadedHandler(evt:Event):void
        {
        	DoSchemaSanityCheck(null);
			
			try
			{
			 UpdateLanguage(da.ResultSet[7][PREFERENCE.VALUE]);
			}
			catch(ex:Error)
			{
				da.DataAccessUpdate("UPDATE PREFERENCE SET VALUE='' where NAME='"+da.ResultSet[0][PREFERENCE.NAME]+"'");
				da.DataAccessUpdate("UPDATE PREFERENCE SET VALUE='' where NAME='"+da.ResultSet[1][PREFERENCE.NAME]+"'");
				
				//this happens only at time of migration
			}
				
        }


		private function localizationXMLHandler(evt:ResultEvent):void
		{			
			
			var xml:String = null;
			if (evt.result is ByteArray)
			{
				var ba:ByteArray = evt.result as ByteArray
				ba.uncompress();			
				ba.position = 0;
				
				//Do not Use
				//var base64Encoder:Base64Encoder = new Base64Encoder();
				//base64Encoder.encodeBytes(ba);
				//xml = base64Encoder.flush();
				
				xml = ba.readUTFBytes(ba.bytesAvailable);				
				
				var cachefolder:File = Helper.CreateCacheDirectory(COMMON.CACHE_FOLDERNAME);
				
				var localizationFile:File = cachefolder.resolvePath(COMMON.FILE_LOCALIZATION);
				
				var stream:FileStream = new FileStream();
				stream.open(localizationFile, FileMode.WRITE);
				stream.writeMultiByte(xml,'UTF-8');
				stream.close();
				
				StateMgr.GetInstance().FormatXml = XML(XML(xml).Formats);
				var languageList:XMLList = XML(xml).language;
				var defaultLanguage:String = "English";
				//Remove Below comment if User's Language is to be made as default language for MOM Desktop for that user
				//-defaultLanguage = StateMgr.GetInstance().SessionObject.Language;
				
				//Using below loop, Tenant's default langauge is set as default language for MOM Desktop for current user.
				for each(var language:XML in languageList)
				{					
					var selected:String = "";
					if("TRUE" == String(language.@isDefault).toUpperCase())
					{
						defaultLanguage = language.@name;	
					}
					
				}
				
				da.DataAccessUpdate("UPDATE PREFERENCE SET VALUE='"+defaultLanguage+"' where NAME='"+da.ResultSet[7][PREFERENCE.NAME]+"'");
				UpdateLanguage(defaultLanguage);
				Application.application.dispatchEvent(new Event(EVENTS.LANGUAGE_CHANGED));
			}
			
		}

		private function UpdateLanguage(newlanguage:String):void
		{
			try
			{
				var oldLanguage:String = StateMgr.GetInstance().Language;
				var tempLanguageNode:XML = null;
				
				StateMgr.GetInstance().Language = newlanguage;	
				
				var cacheFolder:File = Helper.CreateCacheDirectory(COMMON.CACHE_FOLDERNAME);
				
				var file:File= new File(cacheFolder.nativePath + "/" + COMMON.FILE_LOCALIZATION);
				
				var fs:FileStream = new FileStream();
				fs.open(file, FileMode.READ);
				var localizedStrings:XML = XML(fs.readUTFBytes(fs.bytesAvailable));
				
				tempLanguageNode = localizedStrings.language.(@name == newlanguage)[0];
				if(tempLanguageNode != null)
					StateMgr.GetInstance().CurrentCulture = tempLanguageNode.@CultureName;
				
				if(oldLanguage != newlanguage)
				{					
					Application.application.dispatchEvent(new Event(EVENTS.LANGUAGE_CHANGED));
				}
				
				var stringList:XMLList = (localizedStrings.language.(@name == newlanguage)[0]).module.(@name == "framework")[0].string;
				for each(var lstring:XML in stringList)
				{					
					switch(String(lstring.@id))
					{
						case "MD_MESSAGE_RESETDATA_CONFIRM": STRINGS.MESSAGE_RESETDATA_CONFIRM = lstring.@value; break;
						case "MD_MESSAGE_HEADER_RESETDATA": STRINGS.MESSAGE_HEADER_RESETDATA = lstring.@value; break;
						
						case "MD_SCREEN_TITLE_PREFERENCE": STRINGS.SCREEN_TITLE_PREFERENCE = lstring.@value; break;
						case "MD_LABEL_LOGIN": STRINGS.LABEL_LOGIN = lstring.@value; break;
						case "MD_LABEL_PASSWORD": STRINGS.LABEL_PASSWORD = lstring.@value; break;
						case "MD_LABEL_SERVER": STRINGS.LABEL_SERVER = lstring.@value; break;
						case "MD_LABEL_TENANT": STRINGS.LABEL_TENANT = lstring.@value; break;
						
						case "MD_BUTTON_SAVE_SHARED": STRINGS.BUTTON_SAVE = lstring.@value; break;
						case "MD_BUTTON_CANCEL_SHARED": COMMONSTRINGS.BUTTON_CANCEL = STRINGS.BUTTON_CANCEL = lstring.@value; break;
						case "MD_BUTTON_BROWSE": STRINGS.BUTTON_BROWSE = lstring.@value; break;
						case "MD_LABEL_BROWSE_FOR_DIRECTORY": STRINGS.LABEL_BROWSE_FOR_DIRECTORY = lstring.@value; break;
						case "MD_LABEL_REMEMBER_ME": STRINGS.LABEL_REMEMBER_ME = lstring.@value; break;
						case "MD_LABEL_HOT_FOLDER": STRINGS.LABEL_HOT_FOLDER = lstring.@value; break;
						case "MD_BUTTON_PREFERENCE_LINK": STRINGS.BUTTON_PREFERENCE_LINK = lstring.@value; break;
						case "MD_BUTTON_HELP_LINK": STRINGS.BUTTON_HELP_LINK = lstring.@value; break;
						case "MD_BUTTON_ABOUT_LINK": STRINGS.BUTTON_ABOUT_LINK = lstring.@value; break;
						case "MD_BUTTON_OPTIONS_LINK": STRINGS.BUTTON_OPTIONS_LINK = lstring.@value; break;
						case "MD_OPTIONS_RESET_DATA": STRINGS.OPTIONS_RESET_DATA = lstring.@value; break;
						case "MD_OPTIONS_LANGUAGE": STRINGS.OPTIONS_LANGUAGE = lstring.@value; break;
						case "MD_ABOUT_MESSAGE": STRINGS.ABOUT_MESSAGE = lstring.@value; break;
						case "MD_ERROR_LOADING_LANGUAGES": STRINGS.ERROR_LOADING_LANGUAGES = lstring.@value; break;
						case "MD_ERROR_ALL_FIELDS_ARE_MANDATORY": STRINGS.ERROR_ALL_FIELDS_ARE_MANDATORY = lstring.@value; break;
						case "MD_ERROR_COULD_NOT_CONNECT_TO_SERVER": STRINGS.ERROR_COULD_NOT_CONNECT_TO_SERVER = lstring.@value; break;
						case "MD_ERROR_INVALID_CREDENTIALS": STRINGS.ERROR_INVALID_CREDENTIALS = lstring.@value; break;
						case "MD_ERROR_DESKTOP_NOT_COMPATIBLE_WITH_SERVER": STRINGS.ERROR_DESKTOP_NOT_COMPATIBLE_WITH_SERVER = lstring.@value; break;
						case "MD_ERROR_CONNECTION_FAILURE": STRINGS.ERROR_CONNECTION_FAILURE = lstring.@value; break;
						case "MD_ERROR_CATALOGER_CONNECTION_FAILURE": STRINGS.ERROR_CATALOGER_CONNECTION_FAILURE = lstring.@value; break;
						case "MD_WARNING_APP_DOWNGRADE_SCHEMA_CLEAR_WARNING": STRINGS.WARNING_APP_DOWNGRADE_SCHEMA_CLEAR_WARNING = lstring.@value; break;
						case "MD_NETWORK_STATUS_CONNECTED": STRINGS.NETWORK_STATUS_CONNECTED = lstring.@value; break;
						case "MD_NETWORK_STATUS_DISCONNECTED": STRINGS.NETWORK_STATUS_DISCONNECTED = lstring.@value; break;
						case "MD_WIP_VALIDATING_USER_DATA": STRINGS.WIP_VALIDATING_USER_DATA = lstring.@value; break;
						case "MD_WIP_CONFIGURING_SYSTEM": STRINGS.WIP_CONFIGURING_SYSTEM = lstring.@value; break;
						case "MD_WIP_RESYNCING_WITH_SERVER": STRINGS.WIP_RESYNCING_WITH_SERVER = lstring.@value; break;
						case "MD_WIP_MIGRATING_SCHEMA": STRINGS.WIP_MIGRATING_SCHEMA = lstring.@value; break;
						case "MD_DBERROR_DATABASE_FILES_MISSING": STRINGS.DBERROR_DATABASE_FILES_MISSING = lstring.@value; break;
						
						case "MD_MESSAGEBOX_TITLE_ALERT": COMMONSTRINGS.MESSAGEBOX_TITLE_ALERT = lstring.@value; break;
						case "MD_BUTTON_YES": COMMONSTRINGS.BUTTON_YES = lstring.@value; break;
						case "MD_BUTTON_OK": COMMONSTRINGS.BUTTON_OK = lstring.@value; break;
						case "MD_BUTTON_NO": COMMONSTRINGS.BUTTON_NO = lstring.@value; break;
						case "MD_ERROR_DELETE_CONFIRMATION":  COMMONSTRINGS.ERROR_DELETE_CONFIRMATION = lstring.@value; break;
						
					}	
					
				}
				fs.close();
			}
			catch(ex:Error)
			{
				MessageBox.Show(STRINGS.ERROR_LOADING_LANGUAGES);
				StateMgr.GetInstance().logger.Write("Initialize","UpdateLanguage",ex.toString());
				
			}
			
			//update topbar
			topBar.setText();
			
			//update status bar
			preferenceScreen.setText();
			
			MessageBox.setText();
			
			ResetLanguageOptions(newlanguage);
			
		}

		private function ResetLanguageOptions(defaultLanguage:String, disableLanguages:Boolean=false):void
		{
			var OptionsDialogData:XML = new XML("<root></root>");
			var resetDataOption:String = "<menuitem label=\""+ Helper.EncodeSpecialChars(STRINGS.OPTIONS_RESET_DATA) + "\"" + " data=\"" + Helper.EncodeSpecialChars(COMMON.MENU_OPTIONS_RESETDATA) + "\"/>";
			
			var createTicketOption:String = "<menuitem label=\""+ Helper.EncodeSpecialChars(STRINGS.OPTIONS_CREATE_TICKET) + "\"" + " data=\"" + Helper.EncodeSpecialChars(COMMON.MENU_OPTIONS_CREATETICKET) + "\" />";
			OptionsDialogData.appendChild(XML(resetDataOption));
			
			if(!disableLanguages)
			{
				var languagesOptions:XML = GetLanguageOptions(defaultLanguage,disableLanguages);
				OptionsDialogData.appendChild(languagesOptions);
			}
			optionsDialog.dataProvider = OptionsDialogData;
		}

	 	private function disableLanguageMenuHandler(evt:Event):void
		{	
			var currentLanguage:String = StateMgr.GetInstance().Language;
			ResetLanguageOptions(currentLanguage, true);
		}

		private function enableLanguageMenuHandler(evt:Event):void
		{	
			var currentLanguage:String = StateMgr.GetInstance().Language;
			ResetLanguageOptions(currentLanguage, false);
		}
