package	assets.skins	
{
	
	import flash.filters.GlowFilter;
	
	import mx.controls.Alert;
	import mx.core.UIComponent;

	public class ButtonSkin extends UIComponent	{
		
			import flash.display.Graphics;
			import flash.geom.Rectangle;
			import mx.graphics.GradientEntry;
			import mx.graphics.LinearGradient;
			  
			protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void {
			   super.updateDisplayList(unscaledWidth,unscaledHeight);
				var w:Number = unscaledWidth;
				var h:Number = unscaledHeight;
				
				// hold the values of the gradients depending on button state
				var backgroundFillColor:Number;
				var backgroundFillColor2:Number;
				var backgroundFillColor3:Number;
				var backgroundRectColor:Number
								
				var mycolor:Number = getStyle("mycolor");
				
				var fill:LinearGradient = new LinearGradient();
				
				// reference the graphics object of this skin class
				var g:Graphics = graphics;
				g.clear();				
				
				//	which skin is the button currently looking for? Which skin to use?
				switch (name) {
					case "upSkin":
						backgroundFillColor = 0x929292;
						backgroundFillColor2 = mycolor;
						backgroundRectColor = getStyle("bordercolor");
						//setStyle("color",0xFF0000);
						break;
					case "overSkin":
						backgroundFillColor = 0x696969;
						backgroundFillColor2 = 0x504F4F;
						backgroundRectColor = getStyle("color");
						filters = [new GlowFilter(getStyle("themeColor"))];
						
						break;
					case "downSkin":
						backgroundFillColor = 0x888888;
						backgroundFillColor2 = 0x777777;
						backgroundRectColor = getStyle("themeColor");
						color: 0xFFFFFF;
						break;
					case "disabledSkin":
						backgroundFillColor = 0xCCCCCC;
						backgroundFillColor2 = 0xCCCCCC;
						backgroundRectColor = getStyle("border-color");
						break;
				}				
				// depending on which state the button's in, we set our color for the 
				// gradients on the skin
				var g1:GradientEntry = new GradientEntry(getStyle("lgTopColor"),0,100);
				var g2:GradientEntry = new GradientEntry(getStyle("lgBottomColor"),1,100);
				
				g.beginFill(backgroundRectColor,1);
				if(name != "overSkin") 
				{
					g.drawRect(0, 0, unscaledWidth, unscaledHeight);
			 	}
			 	else
			 	{
			 		g.drawRoundRect(0,0,unscaledWidth,unscaledHeight,6,6);
			 	}
			    var borderWidth:Number = 2;
			  	w = w - borderWidth;
			  	h = h - borderWidth;
			  	
				fill.entries = [g1,g2];
				fill.angle = 90;
				// fill the rectangle
				g.moveTo(borderWidth,borderWidth);
				fill.begin(g,new Rectangle(borderWidth,borderWidth,w,h));
				g.lineTo(w,borderWidth);
				g.lineTo(w,h);
				g.lineTo(borderWidth,h);
				g.lineTo(borderWidth,borderWidth);  
				fill.end(g);
				
				
				
				// if we're not showing the down skin, show the shadow. Otherwise hide it on the "down state" to look like it's being pressed
				//if(name != "downSkin") 
				//{	            
		       //     filters = [new DropShadowFilter(4, 45,0x000000,.2)];
				//}
			 }
	}
}