package framework.migration
{
	public class MigrationConfig
	{
		//--------------------------------------------------------------------------
	    //
	    //  Properties(getter/setter)
	    //
	    //--------------------------------------------------------------------------
	
	  
	    //example: "hoge.com";
	    private var _serverDomain:String;
	    public function get ServerDomain():String
	    {
	        return _serverDomain;
	    }
	
	    //example: "foo";
	    private var _serverPath:String;
	    public function get ServerPath():String
	    {
	        return _serverPath;
	    }
	   
	
	   //example: "desktop-version.xml";
	    private var _migrationDefineFileName:String;
	    public function get migrationDefineFileName():String
	    {
	        return _migrationDefineFileName;
	    }
	     
	    private var _previousSchemaVersion:Number;
	    public function get PreviousSchemaVersion():Number
	    {
	        return _previousSchemaVersion;
	    }
	    
	    private var _newSchemaVersion:Number;
	    public function get NewSchemaVersion():Number
	    {
	        return _newSchemaVersion;
	    }
	
	   
	
	    //--------------------------------------------------------------------------
	    //
	    //  Constructor
	    //
	    //--------------------------------------------------------------------------
	    /**
	     * Constructor
	     *
	     * @param ServerDomain 
	     * @param ServerPath 
	     * @param migrationDefineFileName 
	     *
	     */
	    public function MigrationConfig(
	        serverdomain:String
	        ,serverpath:String
	        ,migrationdefinefilename:String
	        ,previousSchemaVersion:Number
	        ,newSchemaVersion:Number)
	    {
	        _serverDomain = serverdomain;
	        _serverPath = serverpath;
	        _migrationDefineFileName = migrationdefinefilename;
	        _previousSchemaVersion = previousSchemaVersion;
	        _newSchemaVersion = newSchemaVersion;	
	    }


	}
}