package framework.utils
{
	import framework.constants.COMMON;
	import framework.constants.tables.PREFERENCE;
	
	public class SessionUtil
	{
		public function SessionUtil()
		{
		}
		
		public static function GetPassword():String
		{
			var password:String = (AssetlinkDesktop.da.ResultSet[1][PREFERENCE.VALUE] == null?"":AssetlinkDesktop.da.ResultSet[1][PREFERENCE.VALUE]);
			if (password.indexOf(COMMON.PASSWORD_ENCRYPTION_IDENTIFIER)>=0)
			{
				password = password.split(COMMON.PASSWORD_ENCRYPTION_IDENTIFIER)[1];
				password = Helper.decrypt(COMMON.PASSWORD_ENCRYPTION_KEY,password);
			}
			return password;
		}
		
		public static function SetPassword(password:String):void
		{	
			AssetlinkDesktop.da.ResultSet[1][PREFERENCE.VALUE] = EncryptPassword(password);
		}
		
		public static function EncryptPassword(password:String):String 
		{
			password = Helper.encrypt(COMMON.PASSWORD_ENCRYPTION_KEY,password);
			password = COMMON.PASSWORD_ENCRYPTION_IDENTIFIER + password; 
			return password; 	
		}

	}
}