package framework.utils
{
	import flash.events.ProgressEvent;
	
	import framework.events.ProgressBarEvent;
	
	import mx.controls.ProgressBarMode;
	import mx.core.Application;
	import mx.core.UIComponent;
	
	
	public class ProgressBarEx extends UIComponent 
	{
		private var bar:mx.controls.ProgressBar;
		private static var internalObject:ProgressBarEx;
				
		public function ProgressBarEx()
		{
			super();
			this.percentWidth = 100;
			this.percentHeight = 100;
		}
		
		
		
		protected override function createChildren():void
		{
			bar = new  mx.controls.ProgressBar();
			bar.mode = ProgressBarMode.MANUAL;
			bar.label = "Importing";
			bar.width = 275;			
			this.addChild(bar);
			bar.addEventListener(ProgressEvent.PROGRESS,Progress);
               
		}
		
		
		
		protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
			this.graphics.clear();
			this.graphics.beginFill(getStyle("backgroundColor"),getStyle("backgroundAlpha"));
			this.graphics.drawRect(0, 0, unscaledWidth, unscaledHeight);
			
			bar.x = (unscaledWidth-bar.width)/2;
			bar.y = (unscaledHeight-bar.height)/2;
		}
		
		
		
		private function Progress(event:ProgressEvent):void
        {
        	//handler1(event);
        //	Alert.show("reafc");
        	//internalObject.dispatchEvent(new ProgressBarEvent(ProgressBarEvent.ON_UPDATE,0,10));
       // 	Alert.show(disp.toString());
        	this.dispatchEvent(new ProgressBarEvent(ProgressBarEvent.ON_UPDATE));
        }
        
        public static function Show(loaded:Number,total:Number):void
		{
			if(internalObject == null)
			{
				internalObject = new ProgressBarEx();	
				Application.application.addChild(internalObject);			
			}
			else
			{
				Application.application.removeChild(internalObject);	
				Application.application.addChild(internalObject);	
			}
			internalObject.visible = true;
			internalObject.bar.setProgress(loaded,total);
		}
		
		public static function SetProgress(loaded:Number,total:Number):void
		{
			if(internalObject != null)
			{
				internalObject.bar.setProgress(loaded,total);
				//internalObject.dispatchEvent(new ProgressBarEvent(ProgressBarEvent.ON_UPDATE,loaded,total));
			}
		}
		
		public static function Hide():void
		{
			if(internalObject != null)
			{				
				internalObject.visible = false;
			}
		}
        
       

		
		
	}
}