package modules.batchcataloger.UI
{
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFieldType;
	import flash.text.TextFormat;
	
	import mx.core.UIComponent;

	public class FileDropArea extends UIComponent
	{
		private var displayText:TextField;
		
		public function FileDropArea(displayName:String)
		{
			super();
			var labelformat:TextFormat = new TextFormat();
			labelformat.font = "verdana";
			labelformat.color = "0XFFFFFF";
			labelformat.size = "14";
			labelformat.bold = false;	
			
			displayText = new TextField();
			displayText.defaultTextFormat = labelformat;
			displayText.autoSize = TextFieldAutoSize.LEFT;
			displayText.border=false;
			displayText.type= TextFieldType.DYNAMIC;
			displayText.selectable=false;
			displayText.mouseEnabled=false;
			displayText.text = displayName;
		}
		
		public function setText(displayName:String):void
		{
			
			displayText.text = displayName;
		}
		
		protected override function createChildren():void
		{
			
			this.addChild(displayText);
		}
		
		protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
			this.graphics.clear();
			
			this.graphics.lineStyle(1,0xffffff);
		//	this.graphics.beginFill(0xffffff);
			this.graphics.drawRect(0, 0, unscaledWidth,unscaledHeight);
        	
			this.graphics.beginFill(0x313131,0.8);
			this.graphics.drawRect(1, 1, unscaledWidth-2, unscaledHeight-2);
			
			displayText.x = (unscaledWidth -  displayText.width)/2;
			displayText.y = (unscaledHeight -  displayText.height)/2;
			
		}
		
	}
}