package modules.batchcataloger.UI.component
{
	import flash.events.MouseEvent;
	
	import modules.batchcataloger.framework.constants.STRINGS;
	import framework.utils.Helper;
	
	import modules.batchcataloger.events.TargetLocationEvent;
	
	import mx.controls.Button;
	import mx.controls.Label;
	import mx.controls.listClasses.IListItemRenderer;
	import mx.core.IDataRenderer;
	import mx.core.UIComponent;

	public class TargetLocation extends UIComponent implements IDataRenderer, IListItemRenderer
	{
		private var dataVal:Object;
		private var select:Button;
		private var label:Label;
		
		public function TargetLocation()
		{
			select = new Button();
			label = new Label();
		}
		
		public function get data():Object
        {
        	return dataVal;
        }
        
		public function set data(value:Object):void
		{				
			dataVal = value;
		 	if(dataVal.TARGETLOCATION != "")
		 	{
				label.text = Helper.Decode(dataVal.TARGETLOCATION);
				//dataVal.TARGETLOCATION = dataVal.TARGETLOCATION.replace(reCase,"/");
			}
			else
			{
				label.text = "";
			}
		}
		
		protected override function createChildren():void
		{
			
			select.styleName = "selecthierarchy";
			this.addChild(label);
			this.addChild(select);
			select.addEventListener(MouseEvent.CLICK,clickHandler);
			
			this.toolTip = "";
		}
		
		protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
			super.updateDisplayList(unscaledWidth,unscaledHeight);
			
			select.setActualSize(90,20);	
			
			label.setActualSize(unscaledWidth-100,20);
			label.x = 0;
			
			select.label = STRINGS.BUTTON_TARGETLOCATION_SELECT;		
			select.x=label.width+5;
			
		}
		
		private function clickHandler(evt:MouseEvent):void
		{
			this.parent.parent.dispatchEvent(new TargetLocationEvent(TargetLocationEvent.SELECT,dataVal));
			//Alert.show(dataVal.ORIGINAL);
			
		}
		
	}
}