package framework.utils
{
	import flash.net.ObjectEncoding;
	
	import framework.constants.ADMODULE;
	import framework.constants.COMMON;
	import framework.utils.Logger;
	
	import mx.messaging.ChannelSet;
	import mx.messaging.channels.AMFChannel;
	import mx.rpc.events.FaultEvent;
	import mx.rpc.remoting.mxml.RemoteObject;
	
	public class RemoteConnection
	{
		public function RemoteConnection()
		{
		}
		
		public function GetCatalogerConnection(url:String):RemoteObject
		{
			var serverurl:String = url;
			var amfChannel:AMFChannel = new AMFChannel("cataloger", serverurl);
		  	amfChannel.netConnection.objectEncoding = ObjectEncoding.AMF3;
		  	var amfChannelSet:ChannelSet = new ChannelSet();
		  	amfChannelSet.addChannel(amfChannel);	  	
		  
		  	
		  	var ro:RemoteObject = new RemoteObject(COMMON.REMOTING_DESTINATION);
			ro.channelSet = amfChannelSet;
			ro.source = COMMON.REMOTING_CATALOGER_SERVICE;
			ro.addEventListener(FaultEvent.FAULT,remoteConnectionHandler);
			return ro;
		}
		
		public function DisconnectCataloger(ro:RemoteObject):RemoteObject
		{
			ro.removeEventListener(FaultEvent.FAULT,remoteConnectionHandler);
			ro.disconnect();
			ro = null;
			return ro;
		}
		
		private function remoteConnectionHandler(evt:FaultEvent):void
		{
			Logger.Write(ADMODULE.UPLOADMANAGER,"UploadManger.as-remoteConnectionHandler()",evt.toString());
			//MessageBox.Show(evt.toString());
		}
	}
}