package assets.checkbox
{
	import events.FacetSeriesChangeEvent;
	
	import flash.events.MouseEvent;
	
	import mx.controls.CheckBox;
	import mx.controls.DataGrid;
	import mx.controls.dataGridClasses.DataGridListData;
	import mx.controls.listClasses.BaseListData;
	import mx.controls.listClasses.IDropInListItemRenderer;
	import mx.controls.listClasses.IListItemRenderer;
	import mx.core.IDataRenderer;
	import mx.core.UIComponent;

	public class CheckBoxItemRenderer extends UIComponent implements IDataRenderer, IListItemRenderer, IDropInListItemRenderer
	{
		[Bindable]
		private var dataVal:Object;
		
		private var cb:CheckBox = null;
		
		
		private var col:DataGridListData;
		private var ownernameArr:Array;
		private var _listData:BaseListData;
		
		public function CheckBoxItemRenderer()
		{
			super();
			cb = new CheckBox();
			cb.styleName = "gridCheckBox"
			
		}
		
		public function get listData():BaseListData
        {
            return _listData;
        }

        /**
         * @private
         */
        public function set listData(value:BaseListData):void
        { 
        	_listData = value;
        	
        }
		
		public function get data():Object
        {
        	return dataVal;
        }
        
		public function set data(value:Object):void
		{				
			dataVal = value;
			cb.selected = (dataVal.SELECTED.toString() == 'true'?true:false);
			
			if(_listData)
			{
                col = DataGridListData(_listData);   
                ownernameArr = col.owner.name.split("$ALSEP$");
   			}
			
		}
		
		protected override function createChildren():void
		{		
			this.addChild(cb);
			this.width = 5;
			cb.addEventListener(MouseEvent.CLICK,clickHandler);
			
		}		
		
		protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
		    cb.x = (unscaledWidth - cb.width)/2-7;
			cb.y = (unscaledHeight - cb.height)/2;
		}
		
		
		
		private function clickHandler(evt:MouseEvent):void
		{
			data.SELECTED = cb.selected; 
			DataGrid(this.owner).dispatchEvent(evt);
			//to do: why thisis done
			if (col.owner.name.indexOf("$ALSEP$")>=0)
			{
				var target1:String = ownernameArr[0] + "$ALSEP$" + ownernameArr[1];
				var target2:DataGridListData = col;
				col.owner.dispatchEvent(new FacetSeriesChangeEvent(FacetSeriesChangeEvent.CHECKBOX_SELECTION, cb, target1, target2)); 
			}	
		}	
		
		
		
		
	}
}